From ccde860981e865972c458371b6de1d756ebeb0fc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 12 2020 00:53:50 +0000
Subject: [PATCH 1040/2232] Tweak target dir finding heuristic


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 128d933..e6de985 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -54,18 +54,19 @@
     clippy::toplevel_ref_arg
 )]
 
-mod cargo;
 mod cfg;
 mod error;
 mod gen;
 mod out;
 mod paths;
 mod syntax;
+mod target;
 
 use crate::error::{Error, Result};
 use crate::gen::error::report;
 use crate::gen::Opt;
-use crate::paths::{PathExt, TargetDir};
+use crate::paths::PathExt;
+use crate::target::TargetDir;
 use cc::Build;
 use std::collections::BTreeMap;
 use std::env;
@@ -135,13 +136,7 @@ impl Project {
         let manifest_dir = paths::manifest_dir()?;
         let out_dir = paths::out_dir()?;
 
-        let target_dir = match cargo::target_dir(&out_dir) {
-            target_dir @ TargetDir::Path(_) => target_dir,
-            // Fallback if Cargo did not work.
-            TargetDir::Unknown => paths::search_parents_for_target_dir(&out_dir),
-        };
-
-        let shared_dir = match target_dir {
+        let shared_dir = match target::find_target_dir(&out_dir) {
             TargetDir::Path(target_dir) => target_dir.join("cxxbridge"),
             TargetDir::Unknown => scratch::path("cxxbridge"),
         };
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 56c0018..4459363 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -3,11 +3,6 @@ use crate::gen::fs;
 use std::ffi::OsStr;
 use std::path::{Component, Path, PathBuf};
 
-pub(crate) enum TargetDir {
-    Path(PathBuf),
-    Unknown,
-}
-
 pub(crate) fn manifest_dir() -> Result<PathBuf> {
     crate::env_os("CARGO_MANIFEST_DIR").map(PathBuf::from)
 }
@@ -44,34 +39,6 @@ impl PathExt for Path {
     }
 }
 
-pub(crate) fn search_parents_for_target_dir(out_dir: &Path) -> TargetDir {
-    // fs::canonicalize on Windows produces UNC paths which cl.exe is unable to
-    // handle in includes.
-    // https://github.com/rust-lang/rust/issues/42869
-    // https://github.com/alexcrichton/cc-rs/issues/169
-    let mut also_try_canonical = cfg!(not(windows));
-
-    let mut dir = out_dir.to_owned();
-    loop {
-        let is_target = dir.ends_with("target");
-        let parent_contains_cargo_toml = dir.with_file_name("Cargo.toml").exists();
-        if is_target && parent_contains_cargo_toml {
-            return TargetDir::Path(dir);
-        }
-        if dir.pop() {
-            continue;
-        }
-        if also_try_canonical {
-            if let Ok(canonical_dir) = out_dir.canonicalize() {
-                dir = canonical_dir;
-                also_try_canonical = false;
-                continue;
-            }
-        }
-        return TargetDir::Unknown;
-    }
-}
-
 #[cfg(unix)]
 pub(crate) use self::fs::symlink_file as symlink_or_copy;
 
diff --git a/gen/build/src/target.rs b/gen/build/src/target.rs
new file mode 100644
index 0000000..58ada3a
--- /dev/null
+++ b/gen/build/src/target.rs
@@ -0,0 +1,42 @@
+use std::env;
+use std::path::{Path, PathBuf};
+
+pub(crate) enum TargetDir {
+    Path(PathBuf),
+    Unknown,
+}
+
+pub(crate) fn find_target_dir(out_dir: &Path) -> TargetDir {
+    if let Some(target_dir) = env::var_os("CARGO_TARGET_DIR") {
+        let target_dir = PathBuf::from(target_dir);
+        if target_dir.is_absolute() {
+            return TargetDir::Path(target_dir);
+        } else {
+            return TargetDir::Unknown;
+        };
+    }
+
+    // fs::canonicalize on Windows produces UNC paths which cl.exe is unable to
+    // handle in includes.
+    // https://github.com/rust-lang/rust/issues/42869
+    // https://github.com/alexcrichton/cc-rs/issues/169
+    let mut also_try_canonical = cfg!(not(windows));
+
+    let mut dir = out_dir.to_owned();
+    loop {
+        if dir.join(".rustc_info.json").exists() || dir.join("CACHEDIR.TAG").exists() {
+            return TargetDir::Path(dir);
+        }
+        if dir.pop() {
+            continue;
+        }
+        if also_try_canonical {
+            if let Ok(canonical_dir) = out_dir.canonicalize() {
+                dir = canonical_dir;
+                also_try_canonical = false;
+                continue;
+            }
+        }
+        return TargetDir::Unknown;
+    }
+}

